Index: /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm
===================================================================
--- /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm	(revision 50158)
+++ /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm	(revision 50159)
@@ -6790,8 +6834,8 @@
     mov dx, strict word 00017h                ; ba 17 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 d2 c7
-    jmp near 04f8ch                           ; e9 4d 01
+    call 0160eh                               ; e8 b3 c7
+    jmp near 04fabh                           ; e9 4d 01
     test byte [bp-008h], 003h                 ; f6 46 f8 03
-    jne near 04f8ch                           ; 0f 85 45 01
+    jne near 04fabh                           ; 0f 85 45 01
     mov al, byte [bp-010h]                    ; 8a 46 f0
     and AL, strict byte 0dfh                  ; 24 df
@@ -6800,6 +6844,6 @@
     mov dx, strict word 00018h                ; ba 18 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 b3 c7
-    jmp near 04f8ch                           ; e9 2e 01
+    call 0160eh                               ; e8 94 c7
+    jmp near 04fabh                           ; e9 2e 01
     mov al, byte [bp-010h]                    ; 8a 46 f0
     or AL, strict byte 010h                   ; 0c 10
@@ -6808,106 +6852,106 @@
     mov dx, strict word 00018h                ; ba 18 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 9c c7
+    call 0160eh                               ; e8 7d c7
     mov bl, byte [bp-00eh]                    ; 8a 5e f2
     xor bl, 010h                              ; 80 f3 10
-    jmp short 04e31h                          ; eb b7
+    jmp short 04e50h                          ; eb b7
     mov al, byte [bp-010h]                    ; 8a 46 f0
     and AL, strict byte 0efh                  ; 24 ef
-    jmp short 04e4ch                          ; eb cb
+    jmp short 04e6bh                          ; eb cb
     mov al, bl                                ; 88 d8
     and AL, strict byte 00ch                  ; 24 0c
     cmp AL, strict byte 00ch                  ; 3c 0c
-    jne short 04e8eh                          ; 75 05
+    jne short 04eadh                          ; 75 05
     jmp far 0f000h:0e05bh                     ; ea 5b e0 00 f0
     test byte [bp-00ah], 080h                 ; f6 46 f6 80
-    jne near 04f8ch                           ; 0f 85 f6 00
+    jne near 04fabh                           ; 0f 85 f6 00
     cmp byte [bp-00ah], 058h                  ; 80 7e f6 58
-    jbe short 04ebah                          ; 76 1e
-    mov bx, 00da6h                            ; bb a6 0d
+    jbe short 04ed9h                          ; 76 1e
+    mov bx, 00da2h                            ; bb a2 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
-    call 018cch                               ; e8 25 ca
+    call 018e1h                               ; e8 1b ca
     movzx ax, byte [bp-00ah]                  ; 0f b6 46 f6
     push ax                                   ; 50
     push 00581h                               ; 68 81 05
     push strict byte 00004h                   ; 6a 04
-    call 0190dh                               ; e8 59 ca
+    call 01922h                               ; e8 4f ca
     add sp, strict byte 00006h                ; 83 c4 06
-    jmp near 04faah                           ; e9 f0 00
+    jmp near 04fc9h                           ; e9 f0 00
     test bl, 008h                             ; f6 c3 08
-    je short 04ed1h                           ; 74 12
+    je short 04ef0h                           ; 74 12
     movzx si, byte [bp-00ah]                  ; 0f b6 76 f6
     imul si, si, strict byte 0000ah           ; 6b f6 0a
-    mov dl, byte [si+00dfah]                  ; 8a 94 fa 0d
-    mov ax, word [si+00dfah]                  ; 8b 84 fa 0d
-    jmp near 04f5dh                           ; e9 8c 00
+    mov dl, byte [si+00df6h]                  ; 8a 94 f6 0d
+    mov ax, word [si+00df6h]                  ; 8b 84 f6 0d
+    jmp near 04f7ch                           ; e9 8c 00
     test bl, 004h                             ; f6 c3 04
-    je short 04ee8h                           ; 74 12
+    je short 04f07h                           ; 74 12
     movzx si, byte [bp-00ah]                  ; 0f b6 76 f6
     imul si, si, strict byte 0000ah           ; 6b f6 0a
-    mov dl, byte [si+00df8h]                  ; 8a 94 f8 0d
-    mov ax, word [si+00df8h]                  ; 8b 84 f8 0d
-    jmp near 04f5dh                           ; e9 75 00
+    mov dl, byte [si+00df4h]                  ; 8a 94 f4 0d
+    mov ax, word [si+00df4h]                  ; 8b 84 f4 0d
+    jmp near 04f7ch                           ; e9 75 00
     mov al, byte [bp-006h]                    ; 8a 46 fa
     and AL, strict byte 002h                  ; 24 02
     test al, al                               ; 84 c0
-    jbe short 04f06h                          ; 76 15
+    jbe short 04f25h                          ; 76 15
     mov al, byte [bp-00ah]                    ; 8a 46 f6
     cmp AL, strict byte 047h                  ; 3c 47
-    jc short 04f06h                           ; 72 0e
+    jc short 04f25h                           ; 72 0e
     cmp AL, strict byte 053h                  ; 3c 53
-    jnbe short 04f06h                         ; 77 0a
+    jnbe short 04f25h                         ; 77 0a
     mov DL, strict byte 0e0h                  ; b2 e0
     movzx si, al                              ; 0f b6 f0
     imul si, si, strict byte 0000ah           ; 6b f6 0a
-    jmp short 04f59h                          ; eb 53
+    jmp short 04f78h                          ; eb 53
     test bl, 003h                             ; f6 c3 03
-    je short 04f38h                           ; 74 2d
+    je short 04f57h                           ; 74 2d
     movzx si, byte [bp-00ah]                  ; 0f b6 76 f6
     imul si, si, strict byte 0000ah           ; 6b f6 0a
-    movzx ax, byte [si+00dfch]                ; 0f b6 84 fc 0d
+    movzx ax, byte [si+00df8h]                ; 0f b6 84 f8 0d
     movzx dx, bl                              ; 0f b6 d3
     test dx, ax                               ; 85 c2
-    je short 04f28h                           ; 74 0a
-    mov dl, byte [si+00df4h]                  ; 8a 94 f4 0d
-    mov ax, word [si+00df4h]                  ; 8b 84 f4 0d
-    jmp short 04f30h                          ; eb 08
-    mov dl, byte [si+00df6h]                  ; 8a 94 f6 0d
-    mov ax, word [si+00df6h]                  ; 8b 84 f6 0d
+    je short 04f47h                           ; 74 0a
+    mov dl, byte [si+00df0h]                  ; 8a 94 f0 0d
+    mov ax, word [si+00df0h]                  ; 8b 84 f0 0d
+    jmp short 04f4fh                          ; eb 08
+    mov dl, byte [si+00df2h]                  ; 8a 94 f2 0d
+    mov ax, word [si+00df2h]                  ; 8b 84 f2 0d
     shr ax, 008h                              ; c1 e8 08
     mov byte [bp-00ah], al                    ; 88 46 f6
-    jmp short 04f63h                          ; eb 2b
+    jmp short 04f82h                          ; eb 2b
     movzx si, byte [bp-00ah]                  ; 0f b6 76 f6
     imul si, si, strict byte 0000ah           ; 6b f6 0a
-    movzx ax, byte [si+00dfch]                ; 0f b6 84 fc 0d
+    movzx ax, byte [si+00df8h]                ; 0f b6 84 f8 0d
     movzx dx, bl                              ; 0f b6 d3
     test dx, ax                               ; 85 c2
-    je short 04f55h                           ; 74 0a
-    mov dl, byte [si+00df6h]                  ; 8a 94 f6 0d
-    mov ax, word [si+00df6h]                  ; 8b 84 f6 0d
-    jmp short 04f5dh                          ; eb 08
-    mov dl, byte [si+00df4h]                  ; 8a 94 f4 0d
-    mov ax, word [si+00df4h]                  ; 8b 84 f4 0d
+    je short 04f74h                           ; 74 0a
+    mov dl, byte [si+00df2h]                  ; 8a 94 f2 0d
+    mov ax, word [si+00df2h]                  ; 8b 84 f2 0d
+    jmp short 04f7ch                          ; eb 08
+    mov dl, byte [si+00df0h]                  ; 8a 94 f0 0d
+    mov ax, word [si+00df0h]                  ; 8b 84 f0 0d
     shr ax, 008h                              ; c1 e8 08
     mov byte [bp-00ah], al                    ; 88 46 f6
     cmp byte [bp-00ah], 000h                  ; 80 7e f6 00
-    jne short 04f83h                          ; 75 1a
+    jne short 04fa2h                          ; 75 1a
     test dl, dl                               ; 84 d2
-    jne short 04f83h                          ; 75 16
-    mov bx, 00da6h                            ; bb a6 0d
+    jne short 04fa2h                          ; 75 16
+    mov bx, 00da2h                            ; bb a2 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
-    call 018cch                               ; e8 54 c9
+    call 018e1h                               ; e8 4a c9
     push 005b8h                               ; 68 b8 05
     push strict byte 00004h                   ; 6a 04
-    call 0190dh                               ; e8 8d c9
+    call 01922h                               ; e8 83 c9
     add sp, strict byte 00004h                ; 83 c4 04
     xor dh, dh                                ; 30 f6
     movzx ax, byte [bp-00ah]                  ; 0f b6 46 f6
-    call 04bc1h                               ; e8 35 fc
+    call 04be0h                               ; e8 35 fc
     mov al, byte [bp-00ah]                    ; 8a 46 f6
     and AL, strict byte 07fh                  ; 24 7f
     cmp AL, strict byte 01dh                  ; 3c 1d
-    je short 04f99h                           ; 74 04
+    je short 04fb8h                           ; 74 04
     and byte [bp-006h], 0feh                  ; 80 66 fa fe
     and byte [bp-006h], 0fdh                  ; 80 66 fa fd
@@ -6915,5 +6959,5 @@
     mov dx, 00096h                            ; ba 96 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 64 c6
+    call 0160eh                               ; e8 45 c6
     lea sp, [bp-004h]                         ; 8d 66 fc
     pop di                                    ; 5f
@@ -6921,5 +6965,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-dequeue_key_:                                ; 0xf4fb1 LB 0x94
+dequeue_key_:                                ; 0xf4fd0 LB 0x94
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -6934,18 +6978,18 @@
     mov dx, strict word 0001ah                ; ba 1a 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0161ch                               ; e8 51 c6
+    call 0161ch                               ; e8 32 c6
     mov bx, ax                                ; 89 c3
     mov dx, strict word 0001ch                ; ba 1c 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0161ch                               ; e8 46 c6
+    call 0161ch                               ; e8 27 c6
     cmp bx, ax                                ; 39 c3
-    je short 05017h                           ; 74 3d
+    je short 05036h                           ; 74 3d
     mov dx, bx                                ; 89 da
     mov ax, strict word 00040h                ; b8 40 00
-    call 01600h                               ; e8 1e c6
+    call 01600h                               ; e8 ff c5
     mov cl, al                                ; 88 c1
     lea dx, [bx+001h]                         ; 8d 57 01
     mov ax, strict word 00040h                ; b8 40 00
-    call 01600h                               ; e8 13 c6
+    call 01600h                               ; e8 f4 c5
     mov es, [bp-008h]                         ; 8e 46 f8
     mov byte [es:si], cl                      ; 26 88 0c
@@ -6953,15 +6997,15 @@
     mov byte [es:di], al                      ; 26 88 05
     cmp word [bp+004h], strict byte 00000h    ; 83 7e 04 00
-    je short 05012h                           ; 74 13
+    je short 05031h                           ; 74 13
     inc bx                                    ; 43
     inc bx                                    ; 43
     cmp bx, strict byte 0003eh                ; 83 fb 3e
-    jc short 05009h                           ; 72 03
+    jc short 05028h                           ; 72 03
     mov bx, strict word 0001eh                ; bb 1e 00
     mov dx, strict word 0001ah                ; ba 1a 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0162ah                               ; e8 18 c6
+    call 0162ah                               ; e8 f9 c5
     mov ax, strict word 00001h                ; b8 01 00
-    jmp short 05019h                          ; eb 02
+    jmp short 05038h                          ; eb 02
     xor ax, ax                                ; 31 c0
     lea sp, [bp-004h]                         ; 8d 66 fc
@@ -6974,22 +7018,23 @@
     or cl, byte [bx+di]                       ; 0a 09
     add ax, 00102h                            ; 05 02 01
-    add bl, ah                                ; 00 e3
+    add byte [bp+si], al                      ; 00 02
+    push bx                                   ; 53
+    sbb byte [bx+di+05fh], dl                 ; 18 51 5f
+    push cx                                   ; 51
+    stosw                                     ; ab
+    push cx                                   ; 51
+    mov bx, 0e551h                            ; bb 51 e5
+    push cx                                   ; 51
+    out DX, AL                                ; ee
+    push cx                                   ; 51
+    pop di                                    ; 5f
     push dx                                   ; 52
-    stc                                       ; f9
-    push ax                                   ; 50
-    inc ax                                    ; 40
-    push cx                                   ; 51
-    mov [bx+di-064h], ss                      ; 8c 51 9c
-    push cx                                   ; 51
-    db  0c6h, 051h, 0cfh, 051h
-    ; mov byte [bx+di-031h], 051h               ; c6 51 cf 51
-    inc ax                                    ; 40
+    nop                                       ; 90
     push dx                                   ; 52
-    jno short 05091h                          ; 71 52
-    sahf                                      ; 9e
+    mov bp, 0f752h                            ; bd 52 f7
     push dx                                   ; 52
-    fcom dword [bp+si+026h]                   ; d8 52 26
+    inc bp                                    ; 45
     push bx                                   ; 53
-_int16_function:                             ; 0xf5045 LB 0x2e7
+_int16_function:                             ; 0xf5064 LB 0x2e7
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -6998,10 +7043,10 @@
     mov dx, strict word 00017h                ; ba 17 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 01600h                               ; e8 ab c5
+    call 01600h                               ; e8 8c c5
     mov cl, al                                ; 88 c1
     mov bh, al                                ; 88 c7
     mov dx, 00097h                            ; ba 97 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 01600h                               ; e8 9e c5
+    call 01600h                               ; e8 7f c5
     mov bl, al                                ; 88 c3
     movzx dx, cl                              ; 0f b6 d1
@@ -7012,5 +7057,5 @@
     xor al, dl                                ; 30 d0
     test ax, ax                               ; 85 c0
-    je short 050d7h                           ; 74 60
+    je short 050f6h                           ; 74 60
     cli                                       ; fa
     mov AL, strict byte 0edh                  ; b0 ed
@@ -7022,9 +7067,9 @@
     ; sub ah, ah                                ; 2a e4
     test AL, strict byte 001h                 ; a8 01
-    jne short 05090h                          ; 75 08
+    jne short 050afh                          ; 75 08
     mov AL, strict byte 021h                  ; b0 21
     mov dx, 00080h                            ; ba 80 00
     out DX, AL                                ; ee
-    jmp short 0507eh                          ; eb ee
+    jmp short 0509dh                          ; eb ee
     mov dx, strict word 00060h                ; ba 60 00
     in AL, DX                                 ; ec
@@ -7032,5 +7077,5 @@
     ; sub ah, ah                                ; 2a e4
     cmp ax, 000fah                            ; 3d fa 00
-    jne short 050d6h                          ; 75 3b
+    jne short 050f5h                          ; 75 3b
     and bl, 0f8h                              ; 80 e3 f8
     movzx ax, bh                              ; 0f b6 c7
@@ -7048,9 +7093,9 @@
     ; sub ah, ah                                ; 2a e4
     test AL, strict byte 001h                 ; a8 01
-    jne short 050c5h                          ; 75 08
+    jne short 050e4h                          ; 75 08
     mov AL, strict byte 021h                  ; b0 21
     mov dx, 00080h                            ; ba 80 00
     out DX, AL                                ; ee
-    jmp short 050b3h                          ; eb ee
+    jmp short 050d2h                          ; eb ee
     mov dx, strict word 00060h                ; ba 60 00
     in AL, DX                                 ; ec
@@ -7060,18 +7105,18 @@
     mov dx, 00097h                            ; ba 97 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 38 c5
+    call 0160eh                               ; e8 19 c5
     sti                                       ; fb
     mov ax, word [bp+012h]                    ; 8b 46 12
     shr ax, 008h                              ; c1 e8 08
     cmp ax, 000a2h                            ; 3d a2 00
-    jnbe near 052e3h                          ; 0f 87 ff 01
+    jnbe near 05302h                          ; 0f 87 ff 01
     push CS                                   ; 0e
     pop ES                                    ; 07
     mov cx, strict word 0000ch                ; b9 0c 00
-    mov di, 05022h                            ; bf 22 50
+    mov di, 05041h                            ; bf 41 50
     repne scasb                               ; f2 ae
     sal cx, 1                                 ; d1 e1
     mov di, cx                                ; 89 cf
-    mov ax, word [cs:di+0502dh]               ; 2e 8b 85 2d 50
+    mov ax, word [cs:di+0504ch]               ; 2e 8b 85 4c 50
     jmp ax                                    ; ff e0
     push strict byte 00001h                   ; 6a 01
@@ -7080,17 +7125,17 @@
     mov dx, ss                                ; 8c d2
     lea ax, [bp-006h]                         ; 8d 46 fa
-    call 04fb1h                               ; e8 a9 fe
+    call 04fd0h                               ; e8 a9 fe
     test ax, ax                               ; 85 c0
-    jne short 05117h                          ; 75 0b
+    jne short 05136h                          ; 75 0b
     push 005efh                               ; 68 ef 05
     push strict byte 00007h                   ; 6a 07
-    call 0190dh                               ; e8 f9 c7
+    call 01922h                               ; e8 ef c7
     add sp, strict byte 00004h                ; 83 c4 04
     cmp byte [bp-006h], 000h                  ; 80 7e fa 00
-    je short 05123h                           ; 74 06
+    je short 05142h                           ; 74 06
     cmp byte [bp-008h], 0f0h                  ; 80 7e f8 f0
-    je short 05129h                           ; 74 06
+    je short 05148h                           ; 74 06
     cmp byte [bp-008h], 0e0h                  ; 80 7e f8 e0
-    jne short 0512dh                          ; 75 04
+    jne short 0514ch                          ; 75 04
     mov byte [bp-008h], 000h                  ; c6 46 f8 00
     movzx dx, byte [bp-006h]                  ; 0f b6 56 fa
@@ -7099,5 +7144,5 @@
     or dx, ax                                 ; 09 c2
     mov word [bp+012h], dx                    ; 89 56 12
-    jmp near 05326h                           ; e9 e6 01
+    jmp near 05345h                           ; e9 e6 01
     or word [bp+01ch], 00200h                 ; 81 4e 1c 00 02
     push strict byte 00000h                   ; 6a 00
@@ -7106,15 +7151,15 @@
     mov dx, ss                                ; 8c d2
     lea ax, [bp-006h]                         ; 8d 46 fa
-    call 04fb1h                               ; e8 5d fe
+    call 04fd0h                               ; e8 5d fe
     test ax, ax                               ; 85 c0
-    jne short 0515fh                          ; 75 07
+    jne short 0517eh                          ; 75 07
     or word [bp+01ch], strict byte 00040h     ; 83 4e 1c 40
-    jmp near 05326h                           ; e9 c7 01
+    jmp near 05345h                           ; e9 c7 01
     cmp byte [bp-006h], 000h                  ; 80 7e fa 00
-    je short 0516bh                           ; 74 06
+    je short 0518ah                           ; 74 06
     cmp byte [bp-008h], 0f0h                  ; 80 7e f8 f0
-    je short 05171h                           ; 74 06
+    je short 05190h                           ; 74 06
     cmp byte [bp-008h], 0e0h                  ; 80 7e f8 e0
-    jne short 05175h                          ; 75 04
+    jne short 05194h                          ; 75 04
     mov byte [bp-008h], 000h                  ; c6 46 f8 00
     movzx dx, byte [bp-006h]                  ; 0f b6 56 fa
@@ -7124,11 +7169,11 @@
     mov word [bp+012h], dx                    ; 89 56 12
     and word [bp+01ch], strict byte 0ffbfh    ; 83 66 1c bf
-    jmp near 05326h                           ; e9 9a 01
+    jmp near 05345h                           ; e9 9a 01
     mov dx, strict word 00017h                ; ba 17 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 01600h                               ; e8 6b c4
+    call 01600h                               ; e8 4c c4
     mov dx, word [bp+012h]                    ; 8b 56 12
     mov dl, al                                ; 88 c2
-    jmp short 0513ah                          ; eb 9e
+    jmp short 05159h                          ; eb 9e
     mov al, byte [bp+010h]                    ; 8a 46 10
     movzx dx, al                              ; 0f b6 d0
@@ -7136,18 +7181,18 @@
     shr ax, 008h                              ; c1 e8 08
     xor ah, ah                                ; 30 e4
-    call 04bc1h                               ; e8 14 fa
+    call 04be0h                               ; e8 14 fa
     test ax, ax                               ; 85 c0
-    jne short 051beh                          ; 75 0d
+    jne short 051ddh                          ; 75 0d
     mov ax, word [bp+012h]                    ; 8b 46 12
     xor al, al                                ; 30 c0
     or AL, strict byte 001h                   ; 0c 01
     mov word [bp+012h], ax                    ; 89 46 12
-    jmp near 05326h                           ; e9 68 01
+    jmp near 05345h                           ; e9 68 01
     and word [bp+012h], 0ff00h                ; 81 66 12 00 ff
-    jmp near 05326h                           ; e9 60 01
+    jmp near 05345h                           ; e9 60 01
     mov ax, word [bp+012h]                    ; 8b 46 12
     xor al, al                                ; 30 c0
     or AL, strict byte 030h                   ; 0c 30
-    jmp short 051b8h                          ; eb e9
+    jmp short 051d7h                          ; eb e9
     mov byte [bp-004h], 002h                  ; c6 46 fc 02
     xor cx, cx                                ; 31 c9
@@ -7162,15 +7207,15 @@
     ; sub ah, ah                                ; 2a e4
     test AL, strict byte 001h                 ; a8 01
-    jne short 051f6h                          ; 75 0d
+    jne short 05215h                          ; 75 0d
     dec bx                                    ; 4b
     test bx, bx                               ; 85 db
-    jbe short 051f6h                          ; 76 08
+    jbe short 05215h                          ; 76 08
     mov dx, 00080h                            ; ba 80 00
     in AL, DX                                 ; ec
     db  02ah, 0e4h
     ; sub ah, ah                                ; 2a e4
-    jmp short 051dfh                          ; eb e9
+    jmp short 051feh                          ; eb e9
     test bx, bx                               ; 85 db
-    jbe short 0523ah                          ; 76 40
+    jbe short 05259h                          ; 76 40
     mov dx, strict word 00060h                ; ba 60 00
     in AL, DX                                 ; ec
@@ -7178,5 +7223,5 @@
     ; sub ah, ah                                ; 2a e4
     cmp ax, 000fah                            ; 3d fa 00
-    jne short 0523ah                          ; 75 35
+    jne short 05259h                          ; 75 35
     mov bx, strict word 0ffffh                ; bb ff ff
     mov dx, strict word 00064h                ; ba 64 00
@@ -7185,15 +7230,15 @@
     ; sub ah, ah                                ; 2a e4
     test AL, strict byte 001h                 ; a8 01
-    jne short 0521fh                          ; 75 0d
+    jne short 0523eh                          ; 75 0d
     dec bx                                    ; 4b
     test bx, bx                               ; 85 db
-    jbe short 0521fh                          ; 76 08
+    jbe short 0523eh                          ; 76 08
     mov dx, 00080h                            ; ba 80 00
     in AL, DX                                 ; ec
     db  02ah, 0e4h
     ; sub ah, ah                                ; 2a e4
-    jmp short 05208h                          ; eb e9
+    jmp short 05227h                          ; eb e9
     test bx, bx                               ; 85 db
-    jbe short 05231h                          ; 76 0e
+    jbe short 05250h                          ; 76 0e
     shr cx, 008h                              ; c1 e9 08
     mov dx, strict word 00060h                ; ba 60 00
@@ -7205,7 +7250,7 @@
     dec byte [bp-004h]                        ; fe 4e fc
     cmp byte [bp-004h], 000h                  ; 80 7e fc 00
-    jnbe short 05205h                         ; 77 cb
+    jnbe short 05224h                         ; 77 cb
     mov word [bp+00ch], cx                    ; 89 4e 0c
-    jmp near 05326h                           ; e9 e6 00
+    jmp near 05345h                           ; e9 e6 00
     push strict byte 00001h                   ; 6a 01
     mov cx, ss                                ; 8c d1
@@ -7213,16 +7258,16 @@
     mov dx, ss                                ; 8c d2
     lea ax, [bp-006h]                         ; 8d 46 fa
-    call 04fb1h                               ; e8 62 fd
+    call 04fd0h                               ; e8 62 fd
     test ax, ax                               ; 85 c0
-    jne short 0525eh                          ; 75 0b
+    jne short 0527dh                          ; 75 0b
     push 005efh                               ; 68 ef 05
     push strict byte 00007h                   ; 6a 07
-    call 0190dh                               ; e8 b2 c6
+    call 01922h                               ; e8 a8 c6
     add sp, strict byte 00004h                ; 83 c4 04
     cmp byte [bp-006h], 000h                  ; 80 7e fa 00
-    je near 0512dh                            ; 0f 84 c7 fe
+    je near 0514ch                            ; 0f 84 c7 fe
     cmp byte [bp-008h], 0f0h                  ; 80 7e f8 f0
-    je near 05129h                            ; 0f 84 bb fe
-    jmp near 0512dh                           ; e9 bc fe
+    je near 05148h                            ; 0f 84 bb fe
+    jmp near 0514ch                           ; e9 bc fe
     or word [bp+01ch], 00200h                 ; 81 4e 1c 00 02
     push strict byte 00000h                   ; 6a 00
@@ -7231,15 +7276,15 @@
     mov dx, ss                                ; 8c d2
     lea ax, [bp-006h]                         ; 8d 46 fa
-    call 04fb1h                               ; e8 2c fd
+    call 04fd0h                               ; e8 2c fd
     test ax, ax                               ; 85 c0
-    je near 05158h                            ; 0f 84 cd fe
+    je near 05177h                            ; 0f 84 cd fe
     cmp byte [bp-006h], 000h                  ; 80 7e fa 00
-    je near 05175h                            ; 0f 84 e2 fe
+    je near 05194h                            ; 0f 84 e2 fe
     cmp byte [bp-008h], 0f0h                  ; 80 7e f8 f0
-    je near 05171h                            ; 0f 84 d6 fe
-    jmp near 05175h                           ; e9 d7 fe
+    je near 05190h                            ; 0f 84 d6 fe
+    jmp near 05194h                           ; e9 d7 fe
     mov dx, strict word 00017h                ; ba 17 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 01600h                               ; e8 59 c3
+    call 01600h                               ; e8 3a c3
     mov dx, word [bp+012h]                    ; 8b 56 12
     mov dl, al                                ; 88 c2
@@ -7247,10 +7292,10 @@
     mov dx, strict word 00018h                ; ba 18 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 01600h                               ; e8 48 c3
+    call 01600h                               ; e8 29 c3
     mov bh, al                                ; 88 c7
     and bh, 073h                              ; 80 e7 73
     mov dx, 00096h                            ; ba 96 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 01600h                               ; e8 3a c3
+    call 01600h                               ; e8 1b c3
     and AL, strict byte 00ch                  ; 24 0c
     or bh, al                                 ; 08 c7
@@ -7259,13 +7304,13 @@
     movzx ax, bh                              ; 0f b6 c7
     sal ax, 008h                              ; c1 e0 08
-    jmp near 05138h                           ; e9 60 fe
+    jmp near 05157h                           ; e9 60 fe
     mov ax, word [bp+012h]                    ; 8b 46 12
     xor ah, ah                                ; 30 e4
     or ah, 080h                               ; 80 cc 80
-    jmp near 051b8h                           ; e9 d5 fe
-    mov bx, 00da6h                            ; bb a6 0d
+    jmp near 051d7h                           ; e9 d5 fe
+    mov bx, 00da2h                            ; bb a2 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
-    call 018cch                               ; e8 de c5
+    call 018e1h                               ; e8 d4 c5
     mov ax, word [bp+012h]                    ; 8b 46 12
     shr ax, 008h                              ; c1 e8 08
